/* Generated by wayland-scanner 1.23.1 */

#ifndef TREELAND_SHORTCUT_MANAGER_V1_CLIENT_PROTOCOL_H
#define TREELAND_SHORTCUT_MANAGER_V1_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client-core.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_treeland_shortcut_manager_v1 The treeland_shortcut_manager_v1 protocol
 * @section page_ifaces_treeland_shortcut_manager_v1 Interfaces
 * - @subpage page_iface_treeland_shortcut_manager_v1 - shortcut manager
 * - @subpage page_iface_treeland_shortcut_context_v1 - client shortcut context
 * @section page_copyright_treeland_shortcut_manager_v1 Copyright
 * <pre>
 *
 * SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
 * SPDX-License-Identifier: Apache-2.0 OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
 * </pre>
 */
struct treeland_shortcut_context_v1;
struct treeland_shortcut_manager_v1;

#ifndef TREELAND_SHORTCUT_MANAGER_V1_INTERFACE
#define TREELAND_SHORTCUT_MANAGER_V1_INTERFACE
/**
 * @page page_iface_treeland_shortcut_manager_v1 treeland_shortcut_manager_v1
 * @section page_iface_treeland_shortcut_manager_v1_desc Description
 *
 * This interface allows a client to get some shell's info.
 *
 * Warning! The protocol described in this file is currently in the testing
 * phase. Backward compatible changes may be added together with the
 * corresponding interface version bump. Backward incompatible changes can
 * only be done by creating a new major version of the extension.
 * @section page_iface_treeland_shortcut_manager_v1_api API
 * See @ref iface_treeland_shortcut_manager_v1.
 */
/**
 * @defgroup iface_treeland_shortcut_manager_v1 The treeland_shortcut_manager_v1 interface
 *
 * This interface allows a client to get some shell's info.
 *
 * Warning! The protocol described in this file is currently in the testing
 * phase. Backward compatible changes may be added together with the
 * corresponding interface version bump. Backward incompatible changes can
 * only be done by creating a new major version of the extension.
 */
extern const struct wl_interface treeland_shortcut_manager_v1_interface;
#endif
#ifndef TREELAND_SHORTCUT_CONTEXT_V1_INTERFACE
#define TREELAND_SHORTCUT_CONTEXT_V1_INTERFACE
/**
 * @page page_iface_treeland_shortcut_context_v1 treeland_shortcut_context_v1
 * @section page_iface_treeland_shortcut_context_v1_desc Description
 *
 * This interface allows a client to listen a shortcut action.
 *
 * Warning! The protocol described in this file is currently in the testing
 * phase. Backward compatible changes may be added together with the
 * corresponding interface version bump. Backward incompatible changes can
 * only be done by creating a new major version of the extension.
 * @section page_iface_treeland_shortcut_context_v1_api API
 * See @ref iface_treeland_shortcut_context_v1.
 */
/**
 * @defgroup iface_treeland_shortcut_context_v1 The treeland_shortcut_context_v1 interface
 *
 * This interface allows a client to listen a shortcut action.
 *
 * Warning! The protocol described in this file is currently in the testing
 * phase. Backward compatible changes may be added together with the
 * corresponding interface version bump. Backward incompatible changes can
 * only be done by creating a new major version of the extension.
 */
extern const struct wl_interface treeland_shortcut_context_v1_interface;
#endif

#define TREELAND_SHORTCUT_MANAGER_V1_REGISTER_SHORTCUT_CONTEXT 0


/**
 * @ingroup iface_treeland_shortcut_manager_v1
 */
#define TREELAND_SHORTCUT_MANAGER_V1_REGISTER_SHORTCUT_CONTEXT_SINCE_VERSION 1

/** @ingroup iface_treeland_shortcut_manager_v1 */
static inline void
treeland_shortcut_manager_v1_set_user_data(struct treeland_shortcut_manager_v1 *treeland_shortcut_manager_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) treeland_shortcut_manager_v1, user_data);
}

/** @ingroup iface_treeland_shortcut_manager_v1 */
static inline void *
treeland_shortcut_manager_v1_get_user_data(struct treeland_shortcut_manager_v1 *treeland_shortcut_manager_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) treeland_shortcut_manager_v1);
}

static inline uint32_t
treeland_shortcut_manager_v1_get_version(struct treeland_shortcut_manager_v1 *treeland_shortcut_manager_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) treeland_shortcut_manager_v1);
}

/** @ingroup iface_treeland_shortcut_manager_v1 */
static inline void
treeland_shortcut_manager_v1_destroy(struct treeland_shortcut_manager_v1 *treeland_shortcut_manager_v1)
{
	wl_proxy_destroy((struct wl_proxy *) treeland_shortcut_manager_v1);
}

/**
 * @ingroup iface_treeland_shortcut_manager_v1
 *
 * The format of the shortcut key is 'Modify+Key', such as 'Ctrl+Alt+T'.
 * If the format is wrong, the synthesizer will give a "format error". If the shortcut
 * key is already registered,
 * the compositor will give a "register error" and issue a destruction to the context.
 */
static inline struct treeland_shortcut_context_v1 *
treeland_shortcut_manager_v1_register_shortcut_context(struct treeland_shortcut_manager_v1 *treeland_shortcut_manager_v1, const char *key)
{
	struct wl_proxy *id;

	id = wl_proxy_marshal_flags((struct wl_proxy *) treeland_shortcut_manager_v1,
			 TREELAND_SHORTCUT_MANAGER_V1_REGISTER_SHORTCUT_CONTEXT, &treeland_shortcut_context_v1_interface, wl_proxy_get_version((struct wl_proxy *) treeland_shortcut_manager_v1), 0, key, NULL);

	return (struct treeland_shortcut_context_v1 *) id;
}

#ifndef TREELAND_SHORTCUT_CONTEXT_V1_ERROR_ENUM
#define TREELAND_SHORTCUT_CONTEXT_V1_ERROR_ENUM
enum treeland_shortcut_context_v1_error {
	/**
	 * shortcut register failed
	 */
	TREELAND_SHORTCUT_CONTEXT_V1_ERROR_REGISTER_FAILED = 1,
};
#endif /* TREELAND_SHORTCUT_CONTEXT_V1_ERROR_ENUM */

/**
 * @ingroup iface_treeland_shortcut_context_v1
 * @struct treeland_shortcut_context_v1_listener
 */
struct treeland_shortcut_context_v1_listener {
	/**
	 */
	void (*shortcut)(void *data,
			 struct treeland_shortcut_context_v1 *treeland_shortcut_context_v1);
};

/**
 * @ingroup iface_treeland_shortcut_context_v1
 */
static inline int
treeland_shortcut_context_v1_add_listener(struct treeland_shortcut_context_v1 *treeland_shortcut_context_v1,
					  const struct treeland_shortcut_context_v1_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) treeland_shortcut_context_v1,
				     (void (**)(void)) listener, data);
}

#define TREELAND_SHORTCUT_CONTEXT_V1_DESTROY 0

/**
 * @ingroup iface_treeland_shortcut_context_v1
 */
#define TREELAND_SHORTCUT_CONTEXT_V1_SHORTCUT_SINCE_VERSION 1

/**
 * @ingroup iface_treeland_shortcut_context_v1
 */
#define TREELAND_SHORTCUT_CONTEXT_V1_DESTROY_SINCE_VERSION 1

/** @ingroup iface_treeland_shortcut_context_v1 */
static inline void
treeland_shortcut_context_v1_set_user_data(struct treeland_shortcut_context_v1 *treeland_shortcut_context_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) treeland_shortcut_context_v1, user_data);
}

/** @ingroup iface_treeland_shortcut_context_v1 */
static inline void *
treeland_shortcut_context_v1_get_user_data(struct treeland_shortcut_context_v1 *treeland_shortcut_context_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) treeland_shortcut_context_v1);
}

static inline uint32_t
treeland_shortcut_context_v1_get_version(struct treeland_shortcut_context_v1 *treeland_shortcut_context_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) treeland_shortcut_context_v1);
}

/**
 * @ingroup iface_treeland_shortcut_context_v1
 *
 * Destroy the context object.
 */
static inline void
treeland_shortcut_context_v1_destroy(struct treeland_shortcut_context_v1 *treeland_shortcut_context_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) treeland_shortcut_context_v1,
			 TREELAND_SHORTCUT_CONTEXT_V1_DESTROY, NULL, wl_proxy_get_version((struct wl_proxy *) treeland_shortcut_context_v1), WL_MARSHAL_FLAG_DESTROY);
}

#ifdef  __cplusplus
}
#endif

#endif
